package si.xml.castor.comparator;

import java.io.*;
import java.util.Iterator;
import java.util.*;

public class c3f {
  
  private RecordsList rlst;
  private RecordsList rlst2;
  
  static Comparator<Record> keyorder = new Comparator<Record>() {

        public int compare(Record o1, Record o2) {
            return o1.getKey().compareTo(o2.getKey());
        }
  };
  
  private ArrayList<Record> sortByKey(ArrayList<Record> lst) {
    
    Collections.sort(lst, keyorder);
    return lst;
    
  }
  
  c3f() {};
  
  c3f(String xml_file_1, String xml_file_2) {

    rlst  = new ListMapUnmarshaller().readFile(xml_file_1);
    rlst2 = new ListMapUnmarshaller().readFile(xml_file_2);

  }
  
  private int compareTwoLists() {
    
    //возвращает 1 - если есть ошибки, 0 - если нет ошибок
        
    ArrayList records = rlst.getRecords(); 
    ArrayList records2 = rlst2.getRecords();
    TreeMap erTM = new TreeMap();
    
    //счетчик ошибок
    int ern = 0;
    
    //сортируем списки
    records = sortByKey(records);
    records2 = sortByKey(records2);

    //проверяем первый список на двойные значения ключа
    String keyPrev = "", keyNext;
    erTM.put( ern, "Проверяем 1-ый список" );
    
    for ( Iterator i = records.iterator(); i.hasNext(); ) {

      Record record = (Record)i.next();
      
      keyNext = record.getKey();
      
      //если есть двойные значения ключа первого списка - заносим в список ошибок
      if (keyNext.equals(keyPrev)) { 
        
        ern++;
        erTM.put( ern, record.getKey() + " - двойное значение ключа в 1-ом списке" );
              
      }
      
      keyPrev = keyNext;

    }
    
    //следующая проверка - 1-ый список проверяем на наличие ключей во 2-ом списке и равенство Признака1 и Признака2
    
    //вспомогательная переменная
    boolean eq1;
    
    for ( Iterator r = records.iterator(); r.hasNext(); ) {
        
        eq1 = false;
        Record record = (Record)r.next();
        
        for ( Iterator k = records2.iterator(); k.hasNext(); ) {

          Record record2 = (Record)k.next();
          
          if ( record2.getKey().equals( record.getKey() ) ) {
            eq1 = true;
            if ( !record2.getValue1().equals( record.getValue1() ) ) {
              ern++;
              erTM.put ( ern, record.getKey() + " (" + record.getValue1() + ", " + record.getValue2() + 
                                        ") - для одного ключа отличие первого признака во 2-ом списке");
            }
            if ( !record2.getValue2().equals( record.getValue2() ) ) {
              ern++;
              erTM.put ( ern, record.getKey() + " (" + record.getValue1() + ", " + record.getValue2() + 
                                        ") - для одного ключа отличие второго признака во 2-ом списке");
            }
          }
        
        }
        
        if ( !eq1 ) { 
          ern++;
          erTM.put( ern, record.getKey() + " - ключ есть в 1-ом и нет во 2-ом списке" );
                
        }
        
    }
    
    //проверяем второй список на двойные значения ключа
    keyPrev = ""; ern++;
    
    erTM.put( ern, "Проверяем 2-ой список" );
    
    for ( Iterator t = records2.iterator(); t.hasNext(); ) {

      Record record = (Record)t.next();
      
      keyNext = record.getKey();
      
      //если есть двойные значения ключа второго списка - заносим в список ошибок
      if (keyNext.equals(keyPrev)) { 
        
        ern++;
        erTM.put( ern, record.getKey() + " - двойное значение ключа во 2-ом списке" );
              
      }
      
      keyPrev = keyNext;

    }
    
    //следующая проверка - 2-ой список проверяем на наличие ключей во 1-ом списке 
    

    for ( Iterator n = records2.iterator(); n.hasNext(); ) {
        eq1 = false;
        Record record = (Record)n.next();
        
        for ( Iterator p = records.iterator(); p.hasNext(); ) {

          Record record2 = (Record)p.next();
          if ( record2.getKey().equals( record.getKey() ) ) {
            eq1 = true;
            if ( !record2.getValue1().equals( record.getValue1() ) ) {
              ern++;
              erTM.put ( ern, record.getKey() + " (" + record.getValue1() + ", " + record.getValue2() + 
                                         ") - для одного ключа отличие первого признака в 1-ом списке");
            }
            if ( !record2.getValue2().equals( record.getValue2() ) ) {
              ern++;
              erTM.put ( ern, record.getKey() + " (" + record.getValue1() + ", " + record.getValue2() + 
                                        ") - для одного ключа отличие второго признака в 1-ом списке");
            }
          }
        
        }
        
        if ( !eq1 ) { 
          ern++;
          erTM.put( ern, record.getKey() + " - ключ есть во 2-ом и нет в 1-ом списке" );
        }
        
    }
    
    //если есть ошибки - сохраняем в файл
    if (ern > 1) {
      saveErrors2file( erTM );  
      return 1;
    } else return 0;
    
  }
  
  public void saveErrors2file(TreeMap err_map) {
    
    try {
      PrintWriter out = new PrintWriter(new FileWriter("errors.log"));
      Set <Map.Entry> entries = err_map.entrySet();
    
      for (Map.Entry entry : entries) {
       out.println( entry.getValue() );
      }
    
      out.close();
    }
    catch (IOException exc) {}
        
  }

  public static void main (String[] args) {

    if( args.length > 0 ) {
       
        if ( args.length == 2 ) {
          c3f lf = new c3f ( args[0], args[1] );
          
          if ( lf.compareTwoLists() == 1 ) {
            System.out.println("::::::::::::::::::::::::::::::::::::::");
            System.out.println("There are errors! See errors.log file!");
            System.out.println("::::::::::::::::::::::::::::::::::::::");
            
          }
          else {
            System.out.println(":::::::::::::::::");
            System.out.println("Lists are equals!");
            System.out.println(":::::::::::::::::");
            
          }
        }
       
    } 
    else {

      System.out.println("Program must to have two parameters!");
      System.exit(0);

    }

  }

}

